<?php
/**********************************************************************
***********************************************************************/

//----------------------------------------------------------------------------------------

function add_supp_allocation($amount, $trans_type_from, $trans_no_from,
	$trans_type_to, $trans_no_to, $date_=null)
{
	if (!$date_)
		$date = Today();

	$date = date2sql($date_);
	$sql = "INSERT INTO ".TB_PREF."supp_allocations (
		amt, date_alloc,
		trans_type_from, trans_no_from, trans_no_to, trans_type_to)
		VALUES (".db_escape($amount).", '$date', "
		.db_escape($trans_type_from).", ".db_escape($trans_no_from).", "
		.db_escape($trans_no_to).", ".db_escape($trans_type_to).")";

	db_query($sql, "A supplier allocation could not be added to the database");
}

//----------------------------------------------------------------------------------------


function delete_supp_allocation($trans_id)
{
	$sql = "DELETE FROM ".TB_PREF."supp_allocations WHERE id = ".db_escape($trans_id);
	db_query($sql, "The existing allocation $trans_id could not be deleted");
}

//----------------------------------------------------------------------------------------

function get_supp_trans_allocation_balance($trans_type, $trans_no)
{
	$sql = "SELECT (ov_amount+ov_gst-ov_discount-alloc) AS BalToAllocate
		FROM ".TB_PREF."supp_trans WHERE trans_no="
		.db_escape($trans_no)." AND type=".db_escape($trans_type);
	$result = db_query($sql,"calculate the allocation");
	$myrow = db_fetch_row($result);

	return $myrow[0];
}

//----------------------------------------------------------------------------------------
//	Update supplier trans alloc field according to current status of supp_allocations
//
function update_supp_trans_allocation($trans_type, $trans_no)
{
	$sql = "UPDATE `".TB_PREF.($trans_type==ST_PURCHORDER ? 'purch_orders' : 'supp_trans')."` trans,
			(SELECT sum(amt) amt from ".TB_PREF."supp_allocations
				WHERE (trans_type_to=".db_escape($trans_type)." AND trans_no_to=".db_escape($trans_no).")
				OR (trans_type_from=".db_escape($trans_type)." AND trans_no_from=".db_escape($trans_no).")) allocated
		SET 
			trans.alloc=IFNULL(allocated.amt, 0)
		WHERE "	. ($trans_type==ST_PURCHORDER ? 
			  "trans.order_no=".db_escape($trans_no)
			: "trans.type=".db_escape($trans_type)." AND trans.trans_no=".db_escape($trans_no));

	db_query($sql, "The supp transaction record could not be modified for the allocation against it");
}


//-------------------------------------------------------------------------------------------------------------

function void_supp_allocations($type, $type_no, $date="")
{
	return clear_supp_alloctions($type, $type_no, $date);
}

//-------------------------------------------------------------------------------------------------------------

function clear_supp_alloctions($type, $type_no, $date="")
{
	// clear any allocations for this transaction
	$sql = "SELECT * FROM ".TB_PREF."supp_allocations
		WHERE (trans_type_from=".db_escape($type)." AND trans_no_from=".db_escape($type_no).")
		OR (trans_type_to=".db_escape($type)." AND trans_no_to=".db_escape($type_no).")";
	$result = db_query($sql, "could not void supp transactions for type=$type and trans_no=$type_no");

	while ($row = db_fetch($result))
	{
                if($row['trans_type_from'] == ST_PURCHORDER){
                        $sql = "UPDATE ".TB_PREF."purch_orders SET alloc=alloc - " . $row['amt'] . "
                                WHERE order_no=" . $row['trans_no_from'];
                }elseif($row['trans_type_to'] == ST_PURCHORDER){
                        $sql = "UPDATE ".TB_PREF."purch_orders SET alloc=alloc - " . $row['amt'] . "
                                WHERE order_no=" . $row['trans_no_to'];
                }else{
                        $sql = "UPDATE ".TB_PREF."supp_trans SET alloc=alloc - " . $row['amt'] . "
                                WHERE (type= " . $row['trans_type_from'] . " AND trans_no=" . $row['trans_no_from'] . ")
                                OR (type=" . $row['trans_type_to'] . " AND trans_no=" . $row['trans_no_to'] . ")";
                }
		db_query($sql, "could not clear allocation");

		// 2008-09-20 Joe Hunt
		if ($date != "")
			exchange_variation($type, $type_no, $row['trans_type_to'], $row['trans_no_to'], $date,
				$row['amt'], PT_SUPPLIER, true);
		// 2014-01-16 Joe Hunt. Fix for voiding allocated currency supp_invoices.		
		elseif ($type == ST_SUPPINVOICE && $row['trans_type_to'] == $type && $row['trans_no_to'] == $type_no)		
			exchange_variation($row['trans_type_from'], $row['trans_no_from'], $row['trans_type_to'], $row['trans_no_to'], 
				sql2date($row['date_alloc']), $row['amt'], PT_SUPPLIER, true);
		//////////////////////
	}


	// remove any allocations for this transaction
	$sql = "DELETE FROM ".TB_PREF."supp_allocations
		WHERE (trans_type_from=".db_escape($type)." AND trans_no_from=".db_escape($type_no).")
		OR (trans_type_to=".db_escape($type)." AND trans_no_to=".db_escape($type_no).")";

	db_query($sql, "could not void supp transactions for type=$type and trans_no=$type_no");
}

//----------------------------------------------------------------------------------------
function get_alloc_supp_sql($extra_fields=null, $extra_conditions=null, $extra_tables=null)
{
	$sql = "SELECT
		trans.type,
		trans.trans_no,
		IF(trans.supp_reference='',trans.reference,trans.supp_reference) as reference,
 		trans.tran_date,
		supplier.supp_name, 
		supplier.curr_code, 
		ov_amount+ov_gst+ov_discount AS Total,
		trans.alloc,
		trans.due_date,
		trans.supplier_id,
                trans.po_no,
		supplier.address";

	if ($extra_fields)
		$sql .= ", $extra_fields ";

	$sql .= " FROM ".TB_PREF."supp_trans as trans, ".TB_PREF."suppliers as supplier";
	if ($extra_tables)
		$sql .= " ,$extra_tables ";

	$sql .= " WHERE trans.supplier_id=supplier.supplier_id";

	if ($extra_conditions)
		$sql .= " AND $extra_conditions";
	
	return $sql;
}


//----------------------------------------------------------------------------------------
function get_allocatable_purch_orders($supplier_id = null, $trans_no=null, $type=null)
{
    
    $sql = "SELECT 
                ".db_escape(ST_PURCHORDER)." type,
                po.order_no trans_no, 
                po.reference,
                po.ord_date tran_date,                 
                supplier.supp_name, 
                supplier.curr_code, 
                (po.total - po.staxes) AS Total, 
                po.alloc,
                po.ord_date due_date, 
                po.supplier_id,
                po.order_no po_no,                 
                supplier.supp_address address,
                IF(alloc_po.amt IS NULL, 0, alloc_po.amt) amt,  
                alloc_po.date_alloc, 
                po.requisition_no supp_reference,
                IF(alloc_invs.amt IS NULL, 0, alloc_invs.amt) invs_amt  ";
            
    $sql .= " FROM ".TB_PREF."purch_orders po 
                JOIN ".TB_PREF."suppliers as supplier 
                    ON po.supplier_id = supplier.supplier_id 
                LEFT JOIN ".TB_PREF."supp_allocations alloc_po  
                    ON alloc_po.trans_type_to = ".db_escape(ST_PURCHORDER)." AND alloc_po.trans_no_to = po.order_no 
                LEFT JOIN ".TB_PREF."purch_order_details pod 
                    ON pod.order_no = po.order_no 
                LEFT JOIN ".TB_PREF."supp_invoice_items sii 
                    ON sii.po_detail_item_id = pod.po_detail_item 
                    AND sii.supp_trans_type = ".db_escape(ST_SUPPINVOICE)."
                LEFT JOIN ".TB_PREF."supp_allocations alloc_invs  
                    ON alloc_invs.trans_type_to = ".db_escape(ST_SUPPINVOICE)." AND alloc_invs.trans_no_to = sii.supp_trans_no 
                
                WHERE po.ord_date > ".db_escape("2021-01-01")." 
                    AND po.approval_status = ".db_escape(AS_APPROVED);
    
    // ALLOW APPROVED POs ONLY
    
    
//    else
//    {
//            $sql .= " AND ISNULL(grn.purch_order_no)"; // only sales orders no yet received
//    }
	
    if ($supplier_id)
            $sql .= " AND po.supplier_id=".db_escape($supplier_id);
    
    if ($trans_no != null and $type != null)
    {
            $sql .= " AND alloc_po.trans_no_from=".db_escape($trans_no)."
                              AND alloc_po.trans_type_from=".db_escape($type);
            
            $sql .= " GROUP BY po.order_no ";
    }
    else{    
            $sql .= " GROUP BY po.order_no 
                        HAVING (amt + invs_amt) < Total ";
    }
    
    return $sql;
    
    /*
     
	$sql = "SELECT
		trans.type,
		trans.trans_no,
		IF(trans.supp_reference='',trans.reference,trans.supp_reference) as reference,
 		trans.tran_date,
		supplier.supp_name, 
		supplier.curr_code, 
		ov_amount+ov_gst+ov_discount AS Total,
		trans.alloc,
		trans.due_date,
		trans.supplier_id,
                trans.po_no,
		supplier.address";

	if ($extra_fields)
		$sql .= ", $extra_fields ";

	$sql .= " FROM ".TB_PREF."supp_trans as trans, ".TB_PREF."suppliers as supplier";
	if ($extra_tables)
		$sql .= " ,$extra_tables ";

	$sql .= " WHERE trans.supplier_id=supplier.supplier_id";

	if ($extra_conditions)
		$sql .= " AND $extra_conditions";
	
	return $sql;
     * 
     */
}


//-------------------------------------------------------------------------------------------------------------

function get_allocatable_from_supp_sql($supplier_id, $settled)
{
	$settled_sql = "";
	if (!$settled)
	{
		$settled_sql = "AND round(ABS(ov_amount+ov_gst+ov_discount)-alloc,6) > 0";
	}

	$supp_sql = "";
	if ($supplier_id != null){
		$supp_sql = " AND trans.supplier_id = ".db_escape($supplier_id);
        }

        $types_sql = " type IN (".ST_SUPPAYMENT.",".ST_SUPPCREDIT.",".ST_BANKPAYMENT.",".ST_SUBCONTRACTOR_CREDIT_NOTE.",".ST_UTILITY_BILL_CREDIT_NOTE.",".ST_CASH_PAYMENT.",".ST_GL_DEBIT.")";
        
//	$sql = get_alloc_supp_sql("round(ABS(ov_amount+ov_gst+ov_discount)-alloc,6) <= 0 AS settled",
//                    "(type=".ST_SUPPAYMENT." OR type=".ST_SUPPCREDIT." OR type=".ST_BANKPAYMENT." OR type=".ST_SUBCONTRACTOR_CREDIT_NOTE." OR type=".ST_UTILITY_BILL_CREDIT_NOTE.") 
//                    AND (ov_amount < 0) " . $settled_sql . $supp_sql);
	$sql = get_alloc_supp_sql("round(ABS(ov_amount+ov_gst+ov_discount)-alloc,6) <= 0 AS settled",
                    $types_sql." AND (ov_amount < 0) " . $settled_sql . $supp_sql);

	return $sql;
}


//-------------------------------------------------------------------------------------------------------------

function get_allocatable_to_supp_transactions($supplier_id, $trans_no=null, $type=null)
{
    global $supplier_credit_types_array;
    
	$sql = "SELECT
                        trans.type,
                        trans.trans_no,
                        IF(trans.supp_reference='',trans.reference,trans.supp_reference) as reference,
                        trans.tran_date,
                        supplier.supp_name, 
                        supplier.curr_code, 
                        ov_amount+ov_gst+ov_discount AS Total,
                        trans.alloc,
                        trans.due_date,
                        trans.supplier_id,
                        trans.po_no,
                        supplier.address,
                        amt,
                        date_alloc, 
                        supp_reference,
                        0 invs_amt 

                FROM ".TB_PREF."supp_trans as trans
			LEFT JOIN ".TB_PREF."supp_allocations as alloc
				ON trans.trans_no = alloc.trans_no_to 
                                AND trans.type = alloc.trans_type_to ,"
	 		.TB_PREF."suppliers as supplier
	 WHERE
	 	 trans.supplier_id=supplier.supplier_id";
        
	if ($supplier_id)
		$sql .= " AND supplier.supplier_id=".db_escape($supplier_id);

	if ($trans_no != null and $type != null)
	{
		$sql .= " AND alloc.trans_no_from=".db_escape($trans_no)."
				  AND alloc.trans_type_from=".db_escape($type);
	}
	else
	{
		$sql .= " AND round(ov_amount+ov_gst+ov_discount-alloc,6) > 0
			AND trans.type IN (".implode(',',$supplier_credit_types_array).")";
		$sql .= " GROUP BY type, trans_no";
	}

	$orders = get_allocatable_purch_orders($supplier_id, $trans_no, $type);
	$sql = "($sql ORDER BY trans_no) \nUNION \n($orders)";
//        $sql = $orders;

	return db_query($sql." ORDER BY due_date", "Cannot retreive alloc to transactions");

}

function get_allocatable_from_supp_transactions($supplier_id, $trans_no=null, $type=null)
{
    global $supplier_credit_types_array;
    
	$sql = "SELECT
		trans.type,
		trans.trans_no,
		IF(trans.supp_reference='',trans.reference,trans.supp_reference) as reference,
 		trans.tran_date,
		supplier.supp_name, 
		supplier.curr_code, 
		ov_amount+ov_gst+ov_discount AS Total,
		trans.alloc,
		trans.due_date,
		trans.supplier_id,
		supplier.address,
		amt,
                date_alloc, 
		supp_reference
	 FROM  ".TB_PREF."supp_trans as trans,"
			.TB_PREF."suppliers as supplier,"
			.TB_PREF."supp_allocations as alloc
	 WHERE trans.supplier_id=supplier.supplier_id
			AND trans.trans_no = alloc.trans_no_from
			AND trans.type = alloc.trans_type_from ";

	if ($trans_no != null and $type != null)
	{
		$sql .=	" AND alloc.trans_no_to=".db_escape($trans_no)."
		  		  AND alloc.trans_type_to=".db_escape($type);
	}
	else
	{
		$sql .= " AND round(ABS(ov_amount+ov_gst+ov_discount)-alloc,6) > 0
			AND trans.type IN (".implode(',',$supplier_credit_types_array).")";
		$sql .= " GROUP BY type, trans_no";
	}
	return db_query($sql." ORDER BY due_date", "Cannot retreive alloc to transactions");
}

function get_sql_for_supplier_allocation_inquiry()
{
 	$date_after = date2sql($_POST['TransAfterDate']);
 	$date_to = date2sql($_POST['TransToDate']);

    $sql = "SELECT 
		trans.type, 
		trans.trans_no,
		trans.reference, 
		supplier.supp_name, 
		trans.supp_reference,
    	trans.tran_date, 
		trans.due_date,
		supplier.curr_code, 
    	(trans.ov_amount + trans.ov_gst  + trans.ov_discount) AS TotalAmount, 
		trans.alloc AS Allocated,
		((trans.type = ".ST_SUPPINVOICE." OR trans.type = ".ST_SUPPCREDIT.") AND trans.due_date < '" . date2sql(Today()) . "') AS OverDue,
		trans.supplier_id
    	FROM "
			.TB_PREF."supp_trans as trans, "
			.TB_PREF."suppliers as supplier
    	WHERE supplier.supplier_id = trans.supplier_id
     	AND trans.tran_date >= '$date_after'
    	AND trans.tran_date <= '$date_to'";

   	if ($_POST['supplier_id'] != ALL_TEXT){
   		$sql .= " AND trans.supplier_id = ".db_escape($_POST['supplier_id']);
    }
   	if (isset($_POST['filterType']) && $_POST['filterType'] != ALL_TEXT)
   	{
   		if (($_POST['filterType'] == '1') || ($_POST['filterType'] == '2'))
   		{
   			$sql .= " AND trans.type = ".ST_SUPPINVOICE." ";
   		}
   		elseif ($_POST['filterType'] == '3')
   		{
			$sql .= " AND trans.type = ".ST_SUPPAYMENT." ";
   		}
   		elseif (($_POST['filterType'] == '4') || ($_POST['filterType'] == '5'))
   		{
			$sql .= " AND trans.type = ".ST_SUPPCREDIT." ";
   		}

   		if (($_POST['filterType'] == '2') || ($_POST['filterType'] == '5'))
   		{
   			$today =  date2sql(Today());
			$sql .= " AND trans.due_date < '$today' ";
   		}
   	}

   	if (!check_value('showSettled'))
   	{
   		$sql .= " AND (round(abs(ov_amount + ov_gst + ov_discount) - alloc,6) != 0) ";
   	}
   	return $sql;
}


function check_po_over_allocations($type, $type_no)
{
    global $SysPrefs;
    
    // All POs directly allocationed from this transaction
    $sql_pos = "SELECT trans_no_to order_no FROM ".TB_PREF."supp_allocations
                WHERE trans_type_from=".db_escape($type)." AND trans_no_from=".db_escape($type_no)." 
                    AND trans_type_to = ".db_escape(ST_PURCHORDER);
    
    // All POs of invoices directly allocationed from this transaction
    $sql_inv_pos = "SELECT po.order_no 
                FROM ".TB_PREF."purch_orders po  
                    JOIN ".TB_PREF."purch_order_details pod 
                        ON pod.order_no = po.order_no 
                    JOIN ".TB_PREF."supp_invoice_items sii 
                        ON sii.po_detail_item_id = pod.po_detail_item 
                        AND sii.supp_trans_type = ".db_escape(ST_SUPPINVOICE)."
                    JOIN ".TB_PREF."supp_allocations alloc_invs  
                        ON alloc_invs.trans_type_to = ".db_escape(ST_SUPPINVOICE)." AND alloc_invs.trans_no_to = sii.supp_trans_no 
                WHERE trans_type_from=".db_escape($type)." AND trans_no_from=".db_escape($type_no);
    
    $sql = $sql_pos." UNION ".$sql_inv_pos;
    
    $result = db_query($sql, "check_po_over_allocations");
    while ($po = db_fetch($result)){
        // Check direct allocations for selected PO
        $alloc_po_sql = "SELECT SUM(alloc_po.amt) alloc_total FROM ".TB_PREF."supp_allocations alloc_po  
                        WHERE alloc_po.trans_type_to = ".db_escape(ST_PURCHORDER)." AND alloc_po.trans_no_to = ".db_escape($po['order_no']);
        $alloc_po_result = db_query($alloc_po_sql, "check_po_over_allocations");
        $po_alloc_total = db_result_value($alloc_po_result, "alloc_total");
        
        // Check invoice allocations for selected PO
        $alloc_inv_sql = "SELECT alloc_invs.*  
                FROM ".TB_PREF."purch_orders po  
                    JOIN ".TB_PREF."purch_order_details pod 
                        ON pod.order_no = po.order_no 
                    JOIN ".TB_PREF."supp_invoice_items sii 
                        ON sii.po_detail_item_id = pod.po_detail_item 
                        AND sii.supp_trans_type = ".db_escape(ST_SUPPINVOICE)."
                    JOIN ".TB_PREF."supp_allocations alloc_invs  
                        ON alloc_invs.trans_type_to = ".db_escape(ST_SUPPINVOICE)." AND alloc_invs.trans_no_to = sii.supp_trans_no 
                WHERE po.order_no =".db_escape($po['order_no'])."                     
                GROUP BY po.order_no";
        
        $alloc_inv_result = db_query($alloc_inv_sql, "check_po_over_allocations");
        
        $inv_alloc_total = 0;
        while ($inv_alloc = db_fetch($alloc_inv_result)){
            $inv_alloc_total += $inv_alloc['amt'];
        }
        
        $poh = get_po_record($po['order_no']);
        $po_total = $poh['total'];
        
//        $SysPrefs->allocation_settled_allowance();
        if($po_alloc_total > 0){
            if($po_total + $SysPrefs->allocation_settled_allowance() < ($po_alloc_total + $inv_alloc_total)){
                $message = "Direct allocations to PO (Rs. ".number_format($po_alloc_total,2).") + allocations to invoices (Rs. ".number_format($inv_alloc_total,2).") exceeded the total value (Rs. ".number_format($po_total,2).") of the PO #".$po['order_no'];
                return array("success"=>false, "message"=>$message);
            }
        }
    }
    
    return array("success"=>true, "message"=>"");

}



function check_transaction_allocated($type_from=0, $type_no_from=0, $type_to=0, $type_no_to=0)
{

    $sql = "SELECT COUNT(id) alloc_recs 
                FROM ".TB_PREF."supp_allocations
                WHERE 1 = 1 ";
    
    if($type_from > 0){
        $sql .= " AND trans_type_from = ".db_escape($type_from);
    }
    
    if($type_no_from > 0){
        $sql .= " AND trans_no_from = ".db_escape($type_no_from);
    }
    
    if($type_to > 0){
        $sql .= " AND trans_type_to = ".db_escape($type_to);
    }
    
    if($type_no_to > 0){
        $sql .= " AND trans_no_to = ".db_escape($type_no_to);
    }
    
    $result = db_query($sql, "check_transaction_allocated");
    
    $k = db_result_value($result, "alloc_recs");
    
    if($k > 0){
        return array("success"=>true, "message"=>"This transaction has allocations.");
    }else{
        return array("success"=>false, "message"=>"This transaction does not have allocations.");        
    }
    
}